<?php

namespace App\Curl;

use App\Exception\CurlInitFailedException;
use CurlHandle;

class CurlRequest
{
    private CurlHandle $curl_handler;

    public function __construct()
    {
        $curl_init = curl_init();
        if ($curl_init == false) {
            throw new CurlInitFailedException();
        }
        $this->curl_handler = $curl_init;
    }

    /** @phpstan-ignore-next-line */
    public function setOptions(array $options_array): void
    {
        curl_setopt_array($this->curl_handler, $options_array);
    }

    /**
     * @return bool|string
     */
    public function execute()
    {
        return curl_exec($this->curl_handler);
    }

    /**
     * @return mixed
     */
    public function getInfo(int $name)
    {
        return curl_getinfo($this->curl_handler, $name);
    }

    public function getErrorMessage(): string
    {
        return curl_error($this->curl_handler) . curl_errno($this->curl_handler);
    }

    public function close(): void
    {
        curl_close($this->curl_handler);
    }
}
