<?php

namespace App\Repository;

use App\Entity\PendingEmailAddress;
use App\Entity\User;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Persistence\ManagerRegistry;

/**
 * @method PendingEmailAddress|null find($id, $lockMode = null, $lockVersion = null)
 * @method PendingEmailAddress|null findOneBy(array $criteria, array $orderBy = null)
 * @method PendingEmailAddress[]    findAll()
 * @method PendingEmailAddress[]    findBy(array $criteria, array $orderBy = null, $limit = null, $offset = null)
 * @template PendingEmailAddress of object
 */
class PendingEmailAddressRepository extends ServiceEntityRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, PendingEmailAddress::class);
    }

    public function findOneByEmail(string $value): ?User
    {
        return $this->createQueryBuilder('u')
            ->andWhere('u.email = :val')
            ->setParameter('val', $value)
            ->getQuery()
            ->getOneOrNullResult()
            ;
    }

    public function emailIsReserved(string $email): bool
    {
        return $this->createQueryBuilder('p')
                ->andWhere('p.email = :email')
                ->setParameter('email', $email)
                ->getQuery()
                ->getOneOrNullResult() !== null;
    }
}
